// touchfan.js

(function(ext) {
    var device = null;
    
	var levels = {
		POWER:0xF30CFF00,
		PLUS:0xE718FF00,
		MINUS:0xA15EFF00,
		SWING:0xF708FF00
	};
    
	ext.resetAll = function(){};
	
	ext.runArduino = function(){
		
	};
	ext.Fan = function(level) {
        runPackage(13,string2array(level));
	// ir.sendNEC([levels[level]],32);
    };
	var _level = 0;
	

    function processData(bytes) {
        trace(bytes);
    }

    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }

    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('demo',function(data) {
            processData(data);
        });
    };

    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
    };

    ext._shutdown = function() {
        if(device) device.close();
        device = null;
    };

    ext._getStatus = function() {
        if(!device) return {status: 1, msg: 'demo disconnected'};
        return {status: 2, msg: 'demo connected'};
    }

    var descriptor = {};
	ScratchExtensions.register('touchfan', descriptor, ext, {type: 'serial'});
})({});
